3 # Copyright (c) 2005, 2006 Junio C Hamano
5 USAGE='[--signoff] [--dotest=<dir>] [--keep] [--utf8 | --no-utf8]
6 [--3way] [--interactive] [--binary]
7 [--whitespace=<option>] [-C<n>] [-p<n>]
9 or, when resuming [--skip | --resolved]'
14 git var GIT_COMMITTER_IDENT >/dev/null || exit
17 echo "$1" >"$dotest/next"
21 stop_here_user_resolve () {
22 if [ -n "$resolvemsg" ]; then
23 printf '%s\n' "$resolvemsg"
26 cmdline=$(basename $0)
27 if test '' != "$interactive"
31 if test '' != "$threeway"
35 if test '.dotest' != "$dotest"
37 cmdline="$cmdline -d=$dotest"
39 echo "When you have resolved this problem run \"$cmdline --resolved\"."
40 echo "If you would prefer to skip this patch, instead run \"$cmdline --skip\"."
46 rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
47 "$dotest/patch" "$dotest/info"
48 echo "$next" >"$dotest/next"
54 echo "Cannot fall back to three-way merge."
59 O_OBJECT=`cd "$GIT_OBJECT_DIRECTORY" && pwd`
61 rm -fr "$dotest"/patch-merge-*
62 mkdir "$dotest/patch-merge-tmp-dir"
64 # First see if the patch records the index info that we can use.
65 git apply -z --index-info "$dotest/patch" \
66 >"$dotest/patch-merge-index-info" &&
67 GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
68 git update-index -z --index-info <"$dotest/patch-merge-index-info" &&
69 GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
70 git write-tree >"$dotest/patch-merge-base+" ||
71 cannot_fallback "Repository lacks necessary blobs to fall back on 3-way merge."
73 echo Using index info to reconstruct a base tree...
74 if GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
75 git apply $binary --cached <"$dotest/patch"
77 mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
78 mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
80 cannot_fallback "Did you hand edit your patch?
81 It does not apply to blobs recorded in its index."
84 test -f "$dotest/patch-merge-index" &&
85 his_tree=$(GIT_INDEX_FILE="$dotest/patch-merge-index" git write-tree) &&
86 orig_tree=$(cat "$dotest/patch-merge-base") &&
87 rm -fr "$dotest"/patch-merge-* || exit 1
89 echo Falling back to patching base and 3-way merge...
91 # This is not so wrong. Depending on which base we picked,
92 # orig_tree may be wildly different from ours, but his_tree
93 # has the same set of wildly different changes in parts the
94 # patch did not touch, so recursive ends up canceling them,
95 # saying that we reverted all those changes.
97 eval GITHEAD_$his_tree='"$SUBJECT"'
98 export GITHEAD_$his_tree
99 git-merge-recursive $orig_tree -- HEAD $his_tree || {
101 echo Failed to merge in the changes.
104 unset GITHEAD_$his_tree
108 dotest=.dotest sign= utf8=t keep= skip= interactive= resolved= binary=
115 -d=*|--d=*|--do=*|--dot=*|--dote=*|--dotes=*|--dotest=*)
116 dotest=`expr "z$1" : 'z-[^=]*=\(.*\)'`; shift ;;
117 -d|--d|--do|--dot|--dote|--dotes|--dotest)
118 case "$#" in 1) usage ;; esac; shift
121 -i|--i|--in|--int|--inte|--inter|--intera|--interac|--interact|\
122 --interacti|--interactiv|--interactive)
123 interactive=t; shift ;;
125 -b|--b|--bi|--bin|--bina|--binar|--binary)
128 -3|--3|--3w|--3wa|--3way)
130 -s|--s|--si|--sig|--sign|--signo|--signof|--signoff)
132 -u|--u|--ut|--utf|--utf8)
133 utf8=t; shift ;; # this is now default
134 --no-u|--no-ut|--no-utf|--no-utf8)
136 -k|--k|--ke|--kee|--keep)
139 -r|--r|--re|--res|--reso|--resol|--resolv|--resolve|--resolved)
145 --whitespace=*|-C*|-p*)
146 git_apply_opt="$git_apply_opt $1"; shift ;;
149 resolvemsg=${1#--resolvemsg=}; shift ;;
160 # If the dotest directory exists, but we have finished applying all the
161 # patches in them, clear it out.
162 if test -d "$dotest" &&
163 last=$(cat "$dotest/last") &&
164 next=$(cat "$dotest/next") &&
166 test "$next" -gt "$last"
173 case "$#,$skip$resolved" in
175 # Explicit resume command and we do not have file, so
179 # No file input but without resume parameters; catch
180 # user error to feed us a patch from standard input
181 # when there is already .dotest. This is somewhat
182 # unreliable -- stdin could be /dev/null for example
183 # and the caller did not intend to feed us a patch but
184 # wanted to continue unattended.
191 die "previous dotest directory $dotest still exists but mbox given."
194 # Make sure we are not given --skip nor --resolved
195 test ",$skip,$resolved," = ,,, ||
196 die "Resolve operation not in progress, we are not resuming."
199 mkdir -p "$dotest" || exit
201 git mailsplit -d"$prec" -o"$dotest" -b -- "$@" > "$dotest/last" || {
206 # -b, -s, -u, -k and --whitespace flags are kept for the
207 # resuming session after a patch failure.
208 # -3 and -i can and must be given when resuming.
209 echo "$binary" >"$dotest/binary"
210 echo " $ws" >"$dotest/whitespace"
211 echo "$sign" >"$dotest/sign"
212 echo "$utf8" >"$dotest/utf8"
213 echo "$keep" >"$dotest/keep"
214 echo 1 >"$dotest/next"
219 files=$(git diff-index --cached --name-only HEAD) || exit
220 if [ "$files" ]; then
221 echo "Dirty index: cannot apply patches (dirty: $files)" >&2
226 if test "$(cat "$dotest/binary")" = t
228 binary=--allow-binary-replacement
230 if test "$(cat "$dotest/utf8")" = t
236 if test "$(cat "$dotest/keep")" = t
240 ws=`cat "$dotest/whitespace"`
241 if test "$(cat "$dotest/sign")" = t
243 SIGNOFF=`git-var GIT_COMMITTER_IDENT | sed -e '
245 s/^/Signed-off-by: /'
251 last=`cat "$dotest/last"`
252 this=`cat "$dotest/next"`
256 this=`expr "$this" + 1`
260 if test "$this" -gt "$last"
267 while test "$this" -le "$last"
269 msgnum=`printf "%0${prec}d" $this`
270 next=`expr "$this" + 1`
271 test -f "$dotest/$msgnum" || {
277 # If we are not resuming, parse and extract the patch information
278 # into separate files:
279 # - info records the authorship and title
280 # - msg is the rest of commit log message
281 # - patch is the patch body.
283 # When we are resuming, these files are either already prepared
284 # by the user, or the user can tell us to do so by --resolved flag.
287 git mailinfo $keep $utf8 "$dotest/msg" "$dotest/patch" \
288 <"$dotest/$msgnum" >"$dotest/info" ||
291 # skip pine's internal folder data
292 grep '^Author: Mail System Internal Data$' \
293 <"$dotest"/info >/dev/null &&
296 test -s $dotest/patch || {
297 echo "Patch is empty. Was it split wrong?"
300 git stripspace < "$dotest/msg" > "$dotest/msg-clean"
304 GIT_AUTHOR_NAME="$(sed -n '/^Author/ s/Author: //p' "$dotest/info")"
305 GIT_AUTHOR_EMAIL="$(sed -n '/^Email/ s/Email: //p' "$dotest/info")"
306 GIT_AUTHOR_DATE="$(sed -n '/^Date/ s/Date: //p' "$dotest/info")"
308 if test -z "$GIT_AUTHOR_EMAIL"
310 echo "Patch does not have a valid e-mail address."
314 export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
316 SUBJECT="$(sed -n '/^Subject/ s/Subject: //p' "$dotest/info")"
317 case "$keep_subject" in -k) SUBJECT="[PATCH] $SUBJECT" ;; esac
321 if test '' != "$SIGNOFF"
324 sed -ne '/^Signed-off-by: /p' \
325 "$dotest/msg-clean" |
329 test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
330 test '' = "$LAST_SIGNED_OFF_BY" && echo
337 printf '%s\n' "$SUBJECT"
338 if test -s "$dotest/msg-clean"
341 cat "$dotest/msg-clean"
343 if test '' != "$ADD_SIGNOFF"
347 } >"$dotest/final-commit"
350 case "$resolved$interactive" in
352 # This is used only for interactive view option.
353 git diff-index -p --cached HEAD >"$dotest/patch"
359 if test "$interactive" = t
362 die "cannot be interactive without stdin connected to a terminal."
364 while test "$action" = again
366 echo "Commit Body is:"
367 echo "--------------------------"
368 cat "$dotest/final-commit"
369 echo "--------------------------"
370 printf "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
374 [aA]*) action=yes interactive= ;;
375 [nN]*) action=skip ;;
376 [eE]*) git_editor "$dotest/final-commit"
379 LESS=-S ${PAGER:-less} "$dotest/patch" ;;
387 if test $action = skip
393 if test -x "$GIT_DIR"/hooks/applypatch-msg
395 "$GIT_DIR"/hooks/applypatch-msg "$dotest/final-commit" ||
400 printf 'Applying %s\n' "$SUBJECT"
405 git apply $git_apply_opt $binary --index "$dotest/patch"
409 # Resolved means the user did all the hard work, and
410 # we do not have to do any patch application. Just
411 # trust what the user has in the index file and the
414 git diff-index --quiet --cached HEAD && {
415 echo "No changes - did you forget to use 'git add'?"
416 stop_here_user_resolve $this
418 unmerged=$(git ls-files -u)
419 if test -n "$unmerged"
421 echo "You still have unmerged paths in your index"
422 echo "did you forget to use 'git add'?"
423 stop_here_user_resolve $this
430 if test $apply_status = 1 && test "$threeway" = t
434 # Applying the patch to an earlier tree and merging the
435 # result may have produced the same tree as ours.
436 git diff-index --quiet --cached HEAD && {
437 echo No changes -- Patch already applied.
441 # clear apply_status -- we have successfully merged.
445 if test $apply_status != 0
447 echo Patch failed at $msgnum.
448 stop_here_user_resolve $this
451 if test -x "$GIT_DIR"/hooks/pre-applypatch
453 "$GIT_DIR"/hooks/pre-applypatch || stop_here $this
456 tree=$(git write-tree) &&
457 echo Wrote tree $tree &&
458 parent=$(git rev-parse --verify HEAD) &&
459 commit=$(git commit-tree $tree -p $parent <"$dotest/final-commit") &&
460 echo Committed: $commit &&
461 git update-ref -m "$GIT_REFLOG_ACTION: $SUBJECT" HEAD $commit $parent ||
464 if test -x "$GIT_DIR"/hooks/post-applypatch
466 "$GIT_DIR"/hooks/post-applypatch